#include "aces.h"

void set_opt(void)
{
tcgetattr(fd, &opt);

opt.c_cflag |= (CLOCAL | CREAD);
opt.c_cflag &= ~PARENB;
opt.c_cflag &= ~CSTOPB;
opt.c_cflag &= ~CSIZE;
opt.c_cflag |= CS8;

opt.c_iflag |= (INPCK | ISTRIP);
opt.c_lflag &= ~(ICANON | ECHO | ISIG);
opt.c_oflag &= ~OPOST;

cfsetispeed(&opt, B115200);
cfsetospeed(&opt, B115200);

tcsetattr(fd, TCSANOW, &opt);
}

void check_for_error(int fd, int num, char *s)
{
if (num == ERROR)
 {
  hangup();
  close(fd);

 }
}


void hangup(void)
{
    int fd1; /* fd for modem (hang up) */

    fd1=open(HANGPORT, O_RDWR | O_NOCTTY | O_NDELAY);
    if (fd1 == ERROR) {
        close(fd1);
        close(fd);
    }

    numbytes=write(fd1, "+++\r", 4);
    check_for_error(fd1, numbytes, "write");

    sleep(1);

    numbytes=write(fd1, "ATH\r", 4);
    check_for_error(fd1, numbytes, "write");

    sleep(3);
    close(fd1);
}

void init_modem(void)
{


  hangup();

  numbytes=write(fd, "ATZ\r", 4);
  check_for_error(fd, numbytes, "write");

  sleep(3);

}

int make_call(void)
{
char s[40];
char buffer[511];


bzero(s,sizeof(s));
bzero(buffer,sizeof(buffer));

init_modem();
open_port();
printf("\033[20;32mDial -> \033[9;36m%s\n",host);
snprintf(s,sizeof(s),"%s%s%c",DIALSTRING,host,'\r');
numbytes=write(fd,s,strlen(s));
check_for_error(fd, numbytes, "write");
if(numbytes==ERROR)
return 0;

printf("\033[9;32mSleeping for \033[9;36m%d \033[9;32mseconds\n",TIMEOUT);
sleep(TIMEOUT);

bzero(buffer,sizeof(buffer));

numbytes = read(fd, buffer, 511);
check_for_error(fd, numbytes, "read");
if(numbytes==ERROR)
return 0;

if((strstr(buffer, "CONNECT")) != NULL) {
hangup();
close(fd);
printf("\033[0;31mMODEM FOUND!\n\n");
fprintf(FP_LOG,"%s -> MODEM FOUND!\n",host);

if(CMP==1) 
{
if(strstr(buffer,STR_CMP)!=NULL)
 {
  printf("\033[0;31mString FOUND! -> \033[20;32m%s\n\n",buffer);
  fprintf(FP_LOG,"String FOUND! -> %s\n\n",buffer);
  return 1;
 }

if ((strstr(buffer,"BUSY")) != NULL) {
fprintf(FP_BUSY,"%s\n",host);
printf("BUSY -> Written in 'BUSY' File\n");
close(fd);
}


return 0;
}

printf("\033[20;32mBuffer -> %s\n\n\n",buffer);
fprintf(FP_LOG,"Buffer -> %s\n\n",buffer);
return 1;
}
if ((strstr(buffer,"BUSY")) != NULL) {
fprintf(FP_BUSY,"%s\n",host);
printf("BUSY -> Written in 'BUSY' File\n");
close(fd);
}
else
{
printf("\033[0;36mModem Not Found\n\n");
close(fd);
return 0;
}
}

int open_port(void)
{
 fd=open(MODEMPORT, O_RDWR | O_NOCTTY | O_NDELAY);
 if(fd==ERROR) exit(ERROR);
}

